import os
import pandas as pd

rd = '/data/inca_vol1/input_data/crop_pollination/input_raw/Agri4Cast/Tmean/'
wd = '/data/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/'

os.chdir(wd)
print(os.getcwd())

dat = [os.path.join(rd,f) for f in os.listdir(rd) if f.endswith('.csv')]


colnames = ["Month_Code", "GRID_NO", "TEMPERATURE_AVG"]
years = [2000,2006,2012,2018,2021]

for year in years:
  df = pd.DataFrame()
  mydat_mean = pd.DataFrame()
  # pick correct files from dat list
  years_2 = [str(year -1), str(year), str(year +1)]
  files = set([file for file in dat for year2 in years_2 if year2 in file]) # Adjust indices as needed



  filename = f'meantemp_{years_2[0]}_{years_2[2]}_monthly.csv'

  for file in files:
    mydat = pd.read_csv(file, sep=';', decimal='.', usecols = ['GRID_NO','TEMPERATURE_AVG','DAY'])

    mydat['DAY'] = pd.to_datetime(mydat['DAY'], format='%Y%m%d')
    mydat['yr'] = mydat['DAY'].dt.strftime('%Y')
    mydat['mnth'] = mydat['DAY'].dt.strftime('%m')

    mydat2_mean = mydat[mydat['yr'].isin(years_2)]
    del mydat

    mydat_mean = pd.concat([mydat_mean, mydat2_mean], ignore_index=True)
    del mydat2_mean

  meantemp_t = mydat_mean.groupby(['mnth', 'GRID_NO'])['TEMPERATURE_AVG'].mean().reset_index()
  del mydat_mean

  meantemp_t = meantemp_t.rename(columns={"mnth": "Month", "GRID_NO": "GRID_NO", "TEMPERATURE_AVG": "Avg_T"})
  mydat = pd.concat([df, meantemp_t], ignore_index=True)

  nodup = mydat.drop_duplicates()
  nameunique = f'unique_{filename}'
  nodup.to_csv(nameunique, index=False, sep=",")
print("end")
