#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# Copyright (c) 2022 European Union.
#
# The tool was developed with the contribution of the Joint Research Centre of the European Commission.
#
# This program is free software: you can redistribute it and/or modify it under the terms of the European Union Public
# Licence, either version 1.2 of the License, or (at your option) any later version.
# You may not use this work except in compliance with the Licence.
#
# You may obtain a copy of the Licence at: https://joinup.ec.europa.eu/collection/eupl/eupl-guidelines-faq-infographics
#
# Unless required by applicable law or agreed to in writing, software distributed under the Licence is distributed on
# an "AS IS" basis, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the Licence for the specific language governing permissions and limitations under the Licence.

################## Importing modules ##################
# standard
import logging
import optparse
import os
import math
import time

# extra official modules
import pandas as pd
import rasterio
import shapefile
import geopandas as gpd
import numpy as np

# own modules
import inca
import inca.common.geoprocessing
import inca.localclimate.preprocessing as preprocessing
############## END importing modules ##################

# global parameters
nameField = 'LAU_NAME'
numField = 'cat'
countryCode = 'CNTR_CODE'
city_id = 'GISCO_ID'

# preprocessing conditions
#remove zeros from list of weather statios for max air temperature
#

logger = logging.getLogger(preprocessing.__name__)

##################### MAIN ##################################

#start main preprocessing script
def main():
    start_time = time.time()
    # parse the arguments
    options = parse_args()

    # ini the logging
    inca.set_up_console_logging(options.verbose)

    # Weather station data
    # remove negative values