import subprocess
import glob
import os
import rasterio
import numpy as np

from inca.common.geoprocessing import GeoProcessing, block_window_generator, RasterType
block_shape = (2048,2048)

accord = GeoProcessing('Dr. De Roo Bert', 'local CLimate Regulation', '/data/inca_vol1/input_data/local_climate_regulation/input_intermediate/Surface_ST/vrts/',
                       ProjectExtentTiff='/home/deroob/LAU_rasterized_inca.tif')

profile = accord.ref_profile
profile.update({'driver':'cog',
                'OVERVIEWS':None,
                'dtype' :np.float32,
                'nodata': np.nan})

for i in ['06','07','08','09','10','03','04','05']:
    accord.Bring2AOI(f'/data/inca_vol1/input_data/local_climate_regulation/input_intermediate/Surface_ST/vrts/eu_{i}_2018.vrt',\
                     f'/data/inca_vol1/input_data/local_climate_regulation/input_intermediate/Surface_ST/vrts/eu_{i}_2018_warped.vrt',
                     raster_type=RasterType.ABSOLUTE_POINT)


    with rasterio.open(f'/data/inca_vol1/input_data/local_climate_regulation/input_intermediate/Surface_ST/vrts/{i}_LST_2018_eu_masked.tif',
                       'w', **profile) as ds_out,  \
        rasterio.open('/home/deroob/LAU_rasterized_inca.tif') as src_mask,\
        rasterio.open(f'/data/inca_vol1/input_data/local_climate_regulation/input_intermediate/Surface_ST/vrts/eu_{i}_2018_warped.vrt') as src_data:

        for _, window in block_window_generator(block_shape, ds_out.height, ds_out.width):
            print(_)
            mask = src_mask.read(window=window)
            if np.all(mask == 0):
                continue
            data = src_data.read(window=window)
            data[mask==0] = ds_out.nodata
            ds_out.write(data, window=window)